<template>
  <ck-base-item-bis
    :loading="updating"
    :tabindex="tabindex"
    :item-id="item.id"
    :label="item.label"
    :checked="item.ticked"
    :focus-on-mount="focusOnMount"
    :collection-id="collectionId"
    :apparitionOrder="item.ordre"
    @setup-create="$emit('setup-create')"
    @item-update="update"
  >
    <template #checkbox="{ color }">
      <v-progress-circular :color="color" size="25" width="5" :model-value="pourcentage"></v-progress-circular>
    </template>
    <template #edit>
      <counter-item-form
        v-model="editingItem"
      ></counter-item-form>
    </template>
    <template #complement>
      <v-number-input
        :loading="updating"
        v-model="editingItem.actualCount"
        label="count"
        control-variant="split"
        hide-details
        readonly
        @update:modelValue="quickUpdate"
      ></v-number-input>
    </template>
  </ck-base-item-bis>
</template>

<script>
import { toRaw } from 'vue'
import CkBaseItemBis from '@/components/item/ck-base-item.vue'
import CounterItemForm from '@/components/item/counter/counter-item-form.vue'
import { useCollectionsStore } from '@/stores/itemCollections.js'

export default {
  components: { CounterItemForm, CkBaseItemBis },
  props: {
    item: {
      type: Object,
      required: true
    },
    tabindex: {
      type: Number,
      required: true
    },
    focusOnMount:  {
      type: Boolean,
      default: false
    },
    collectionId:  {
      type: String,
      required: true
    },
  },
  data() {
    return {
      editingItem: {},
      updating: false,
      quickupdateIterval: undefined
    }
  },
  computed: {
    pourcentage() {
      return 100*this.item.actualCount/this.item.objectiveCount
    },
    floor() {
      return Math.min(this.item.actualCount, this.item.objectiveCount)
    },
  },
  methods: {
    update() {
      this.updating = true
      useCollectionsStore().updateCounterItem(this.collectionId, this.item.id, this.editingItem).then(() => {
        this.editingItem = structuredClone(toRaw(this.item))
        clearInterval(this.quickupdateIterval)
        this.updating = false
      })
    },
    quickUpdate() {
      this.updating = true
      clearInterval(this.quickupdateIterval)
      this.quickupdateIterval = setInterval(() => this.update(), 1000)
    }
  },
  mounted() {
    this.editingItem = structuredClone(toRaw(this.item))
  }
}
</script>
